// cmd here
// author: Masashi N.

(function main()
{
	var Version = "0.01";

	function VersionInfo()
	{
		return String(
			"cmdhere installation script  version " + Version + "\n" +
			"\n" +
			"Running WSH: version " + WScript.Version + " build " + WScript.BuildVersion + "\n" +
			"");
	}

	function Usage()
	{
		return String(
			"g : cmdhere.js [/I | /U]" + "\n" +
			"\n" +
			"IvV :" + "\n" +
			" /I        CXg[" + "\n" +
			" /U        ACXg[" + "\n" +
			" /Help     ̃wv\" + "\n" +
			" /Version  XNvg̃o[W\" + "\n" +
			"");
	}

	var WSShell = null;	// WScript shell object
	var ConfirmTitle = WScript.Name;	// title of confirm dialog
	var ConfirmSubtitle = "";	// subtitle of confirm dialog
	var Args = WScript.Arguments;
	var MenuItemText = "R}hvvg(&P)";
	var MenuItemRegKey = "cmdhere";
	var ExecCmdString = "cmd.exe /k \"cd %L\"";

	// check mode
	if (!WScript.Interactive) {
		EchoForBatchMode("ob`[hł͓삵܂.");
		WScript.Quit(0x110);
	}

	// check arguments and environment
	if (Args.Named.Exists("V") || Args.Named.Exists("Version")) Quit(0x0, VersionInfo());
	if (Args.Named.Exists("?") || Args.Named.Exists("Help")|| Args.Named.Exists("H")) Quit(0x0, Usage());

	var fDebug = Args.Named.Exists("Debug");
	var fCScript = WScript.FullName.substring(WScript.FullName.length - 12).toLowerCase() == "\\cscript.exe";
	CheckError(fCScript && (!WScript.StdOut || !WScript.StdIn), 0x101, "CScript ŎsĂ܂ StdIn, StdOut pł܂.");

	var fConfirm = Args.Named.Exists("Confirm");

	if (Args.Named.Exists("I") || Args.Named.Exists("Install")) return Install();
	if (Args.Named.Exists("U") || Args.Named.Exists("Uninstall")) return Uninstall();

	CheckError(Args.Count() != 0, 0x108, "IvVԈĂ܂.");
	
	// run prompt
	var msg;
	if (fCScript) {
		msg = "uR}hvvgvj[ ZbgAbv vO" + "\n\n" +
			"ReLXgj[ւ̒ǉsꍇ Y ͂Ă." + "\n" +
			"ReLXgj[̍폜sꍇ N ͂Ă." + "\n" +
			"߂ꍇ C ͂Ă." + "\n";
	} else {
		ConfirmTitle = "uR}hvvgvj[ ZbgAbv vO";
		ConfirmSubtitle = "";
		msg =
			"ReLXgj[ւ̒ǉsꍇ [ ͂ ] NbNĂ." + "\n" +
			"ReLXgj[̍폜sꍇ [  ] NbNĂ." + "\n" +
			"߂ꍇ [ LZ ] NbNĂ." + "\n";
	}
	var RetVal = ConfirmYesNoCancel(msg, 2);
	if (RetVal < 0) Quit(0x1);
	return (RetVal > 0) ? Install() : Uninstall();
	
	//////////////////////////////////////////////////////

	function Quit(qcode, msg)
	{
		if (msg) {
			for (var i = 2; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			WScript.Echo(msg);
		}
		WScript.Quit(qcode);
	}

	function EchoForBatchMode(msg)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
		} else {
			GetWSShell().Popup(msg);
		}
	}
	
	function GetWSShell()
	{
		if (!WSShell) {
			WSShell = WScript.CreateObject("WScript.Shell");
			CheckError(!WSShell, 0x205, "WScriptVFIuWFNg쐬ł܂ł.");
		}
		return WSShell;
	}

	//////////////////////////////////////////////////////
	// error and warning
	//
	// successful quit code is from 0 to 0xFF.
	// faital error code is from 0x0100 to 0x0FFF.
	// warning code is from 0x1100 to 0x1FFF.
	
	// 0  normally quit. including VersionInfo and Usage
	// 1  quit by cancel.
	// 0x100-0x1FF arguments and environment error
	//   0x100-0x10F  environment flags and variables
	// 0x200-0x2FF object creation error
	//   0x200-0x20F  WScript.Shell objects
	// 0x400-0x7FF  setup operation
	//   0x400-0x5FF  registry operation in setup
	//   0x610-0x7FF  registry operation in unsetup

	function CheckError(iferror, code, msg)
	{
		if (iferror) {
			msg = "ERROR " + code +" : " + msg;
			for (var i = 3; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			Quit(code, msg);
		}
	}

	function CheckWarning(ifwarn, code, msg)
	{
		if (ifwarn) {
			msg = "Warning " + code +" : " + msg;
			if (LogFile) {
				LogFile.WriteLine(msg);
				for (var i = 3; i < arguments.length; ++i)
					LogFile.WriteLine(arguments[i]);
			}
			for (var i = 3; i < arguments.length; ++i)
				msg += "\n" + arguments[i];
			WScript.Echo(msg);
		}
	}

	//////////////////////////////////////////////////////
	// confirmation

	function ConfirmYesNo(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Yes/No ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "Y") return 1;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x24 | (defbtn * 0x100));
			if (ret == 0x06) return 1;
		}
		return 0;
	}
	
	function ConfirmYesNoCancel(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Yes/No/Cancel ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "Y") return 1;
			if (answer == "N") return 0;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x23 | (defbtn * 0x100));
			if (ret == 0x06) return 1;
			if (ret == 0x07) return 0;
		}
		return -1;
	}

	function ConfirmOkCancel(msg, defbtn)
	{
		if (fCScript) {
			WScript.StdOut.WriteLine(msg);
			WScript.StdOut.Write("Ok/Cancel ? ");
			var answer = WScript.StdIn.ReadLine();
			answer = answer.charAt(0).toUpperCase();
			if (answer == "O") return 1;
		} else {
			var ret = GetWSShell().Popup(msg, 0, ConfirmTitle+ConfirmSubtitle, 0x21 | (defbtn * 0x100));
			if (ret == 0x01) return 1;
		}
		return -1;
	}

	//////////////////////////////////////////////////////
	// install / uninstall

	function Install()
	{
		if (fConfirm) {
			ConfirmSubtitle = "";
			var RetVal = ConfirmOkCancel("uR}hvvgvڂfBNgƃhCũReLXgj[ɒǉ܂.", 1);
			if (RetVal <= 0) Quit(0x1);
		}

		InstallKey("Directory", 0x400);
		InstallKey("Drive", 0x600);
		
		WScript.Echo("CXg[͐Ɋ܂.");
		return 0;

		function InstallKey(keyname, ecflag) {
			var RegPath = "HKCR\\" + keyname + "\\shell\\" + MenuItemRegKey + "\\";
			try {
				if (GetWSShell().RegRead(RegPath)) {
					CheckError(true, 0x001 | ecflag, keyname + " ̃ReLXgj[ɂłɃCXg[Ă悤ł.");
				}
			} catch (e) {
				if (fDebug) WScript.Echo("WXgL[ " + RegPath + " ͓ǂݎ܂ł.");
			}

			try {
				GetWSShell().RegWrite(RegPath, MenuItemText);
				GetWSShell().RegWrite(RegPath + "command\\", ExecCmdString);
			} catch (e) {
				CheckError(e, 0x00A | ecflag, keyname + " ̃WXgւ݂̏Ɏs܂.");
			}
		}
	}

	function Uninstall()
	{
		if (fConfirm) {
			ConfirmSubtitle = "";
			var RetVal = ConfirmOkCancel("uR}hvvgvڂfBNgƃhCũReLXgj[폜܂.", 1);
			if (RetVal <= 0) Quit(0x1);
		}

		UninstallKey("Directory", 0x400);
		UninstallKey("Drive", 0x600);

		WScript.Echo("폜͐Ɋ܂.");
		return 0;

		function UninstallKey(keyname, ecflag) {
			var RegPath = "HKCR\\" + keyname + "\\shell\\" + MenuItemRegKey + "\\";

			// check reg key
			try {
				GetWSShell().RegRead(RegPath);
			} catch (e) {
				CheckError(e, 0x112 | ecflag, "WXgL[ " + RegPath + " ǂݎ܂ł.",
					"j[̓CXg[ĂȂ\܂.");
			}

			// delete reg key
			try {
				GetWSShell().RegDelete(RegPath + "command\\");
				GetWSShell().RegDelete(RegPath);
			} catch (e) {
				CheckError(e, 0x11A | ecflag, "WXgL[̍폜Ɏs܂.", RegPath);
			}
		}
	}

})();	// end of main()
